/*

 Uniform v2.1.0
 Copyright © 2009 Josh Pyles / Pixelmatrix Design LLC
 http://pixelmatrixdesign.com

 Requires jQuery 1.3 or newer

 Much thanks to Thomas Reynolds and Buck Wilson for their help and advice on
 this.

 Disabling text selection is made possible by Mathias Bynens
 <http://mathiasbynens.be/> and his noSelect plugin.
 <https://github.com/mathiasbynens/jquery-noselect>, which is embedded.

 Also, thanks to David Kaneda and Eugene Bond for their contributions to the
 plugin.

 Tyler Akins has also rewritten chunks of the plugin, helped close many issues,
 and ensured version 2 got out the door.

 License:
 MIT License - http://www.opensource.org/licenses/mit-license.php

 Enjoy!

 */
/*global jQuery, window, document, navigator*/
(function(e,t){"use strict";function n(e){var t=Array.prototype.slice.call(arguments,1);return e.prop?e.prop.apply(e,t):e.attr.apply(e,t)}function r(e,t,n){var r,i;for(r in n)n.hasOwnProperty(r)&&(i=r.replace(/ |$/g,t.eventNamespace),e.bind(i,n[r]))}function i(e,t,n){r(e,n,{focus:function(){t.addClass(n.focusClass)},blur:function(){t.removeClass(n.focusClass),t.removeClass(n.activeClass)},mouseenter:function(){t.addClass(n.hoverClass)},mouseleave:function(){t.removeClass(n.hoverClass),t.removeClass(n.activeClass)},"mousedown touchbegin":function(){e.is(":disabled")||t.addClass(n.activeClass)},"mouseup touchend":function(){t.removeClass(n.activeClass)}})}function s(e,t){e.removeClass(t.hoverClass+" "+t.focusClass+" "+t.activeClass)}function o(e,t,n){n?e.addClass(t):e.removeClass(t)}function u(e,t,n){var r="checked",i=t.is(":"+r);t.prop?t.prop(r,i):i?t.attr(r,r):t.removeAttr(r),o(e,n.checkedClass,i)}function a(e,t,n){o(e,n.disabledClass,t.is(":disabled"))}function f(e,t,n){switch(n){case"after":return e.after(t),e.next();case"before":return e.before(t),e.prev();case"wrap":return e.wrap(t),e.parent()}return null}function l(t,r,i){var s,o,u;return i||(i={}),i=e.extend({bind:{},divClass:null,divWrap:"wrap",spanClass:null,spanHtml:null,spanWrap:"wrap"},i),s=e("<div />"),o=e("<span />"),r.autoHide&&t.is(":hidden")&&t.css("display")==="none"&&s.hide(),i.divClass&&s.addClass(i.divClass),r.wrapperClass&&s.addClass(r.wrapperClass),i.spanClass&&o.addClass(i.spanClass),u=n(t,"id"),r.useID&&u&&n(s,"id",r.idPrefix+"-"+u),i.spanHtml&&o.html(i.spanHtml),s=f(t,s,i.divWrap),o=f(t,o,i.spanWrap),a(s,t,r),{div:s,span:o}}function c(t,n){var r;return n.wrapperClass?(r=e("<span />").addClass(n.wrapperClass),r=f(t,r,"wrap"),r):null}function h(){var t,n,r,i;return i="rgb(120,2,153)",n=e('<div style="width:0;height:0;color:'+i+'">'),e("body").append(n),r=n.get(0),window.getComputedStyle?t=window.getComputedStyle(r,"").color:t=(r.currentStyle||r.style||{}).color,n.remove(),t.replace(/ /g,"")!==i}function p(t){return t?e("<span />").text(t).html():""}function d(){return navigator.cpuClass&&!navigator.product}function v(){return typeof window.XMLHttpRequest!="undefined"?!0:!1}function m(e){var t;return e[0].multiple?!0:(t=n(e,"size"),!t||t<=1?!1:!0)}function g(){return!1}function y(e,t){var n="none";r(e,t,{"selectstart dragstart mousedown":g}),e.css({MozUserSelect:n,msUserSelect:n,webkitUserSelect:n,userSelect:n})}function b(e,t,n){var r=e.val();r===""?r=n.fileDefaultHtml:(r=r.split(/[\/\\]+/),r=r[r.length-1]),t.text(r)}function w(e,t,n){var r,i;r=[],e.each(function(){var e;for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&(r.push({el:this,name:e,old:this.style[e]}),this.style[e]=t[e])}),n();while(r.length)i=r.pop(),i.el.style[i.name]=i.old}function E(e,t){var n;n=e.parents(),n.push(e[0]),n=n.not(":visible"),w(n,{visibility:"hidden",display:"block",position:"absolute"},t)}function S(e,t){return function(){e.unwrap().unwrap().unbind(t.eventNamespace)}}var x=!0,T=!1,N=[{match:function(e){return e.is("a, button, :submit, :reset, input[type='button']")},apply:function(e,t){var o,u,f,c,h;return u=t.submitDefaultHtml,e.is(":reset")&&(u=t.resetDefaultHtml),e.is("a, button")?c=function(){return e.html()||u}:c=function(){return p(n(e,"value"))||u},f=l(e,t,{divClass:t.buttonClass,spanHtml:c()}),o=f.div,i(e,o,t),h=!1,r(o,t,{"click touchend":function(){var t,r,i,s;if(h)return;if(e.is(":disabled"))return;h=!0,e[0].dispatchEvent?(t=document.createEvent("MouseEvents"),t.initEvent("click",!0,!0),r=e[0].dispatchEvent(t),e.is("a")&&r&&(i=n(e,"target"),s=n(e,"href"),!i||i==="_self"?document.location.href=s:window.open(s,i))):e.click(),h=!1}}),y(o,t),{remove:function(){return o.after(e),o.remove(),e.unbind(t.eventNamespace),e},update:function(){s(o,t),a(o,e,t),e.detach(),f.span.html(c()).append(e)}}}},{match:function(e){return e.is(":checkbox")},apply:function(e,t){var n,o,f;return n=l(e,t,{divClass:t.checkboxClass}),o=n.div,f=n.span,i(e,o,t),r(e,t,{"click touchend":function(){u(f,e,t)}}),u(f,e,t),{remove:S(e,t),update:function(){s(o,t),f.removeClass(t.checkedClass),u(f,e,t),a(o,e,t)}}}},{match:function(e){return e.is(":file")},apply:function(t,o){function v(){b(t,h,o)}var u,c,h,p;return u=l(t,o,{divClass:o.fileClass,spanClass:o.fileButtonClass,spanHtml:o.fileButtonHtml,spanWrap:"after"}),c=u.div,p=u.span,h=e("<span />").html(o.fileDefaultHtml),h.addClass(o.filenameClass),h=f(t,h,"after"),n(t,"size")||n(t,"size",c.width()/10),i(t,c,o),v(),d()?r(t,o,{click:function(){t.trigger("change"),setTimeout(v,0)}}):r(t,o,{change:v}),y(h,o),y(p,o),{remove:function(){return h.remove(),p.remove(),t.unwrap().unbind(o.eventNamespace)},update:function(){s(c,o),b(t,h,o),a(c,t,o)}}}},{match:function(e){if(e.is("input")){var t=(" "+n(e,"type")+" ").toLowerCase(),r=" color date datetime datetime-local email month number password search tel text time url week ";return r.indexOf(t)>=0}return!1},apply:function(e,t){var r,s;return r=n(e,"type"),e.addClass(t.inputClass),s=c(e,t),i(e,e,t),t.inputAddTypeAsClass&&e.addClass(r),{remove:function(){e.removeClass(t.inputClass),t.inputAddTypeAsClass&&e.removeClass(r),s&&e.unwrap()},update:g}}},{match:function(e){return e.is(":radio")},apply:function(t,o){var f,c,h;return f=l(t,o,{divClass:o.radioClass}),c=f.div,h=f.span,i(t,c,o),r(t,o,{"click touchend":function(){var r;r=n(t,"name"),r=r.replace(/(["\\])/g,"\\$1"),e.uniform.update(e(':radio[name="'+r+'"]'))}}),u(h,t,o),{remove:S(t,o),update:function(){s(c,o),u(h,t,o),a(c,t,o)}}}},{match:function(e){return e.is("select")&&!m(e)?!0:!1},apply:function(t,n){function p(){var e={borderWidth:"0px",display:"inline",width:"auto"};h&&(e.fontSize=h),w(t,e,function(){E(t,function(){c=t.width(),h||(h=t.css("fontSize"))})})}function d(){var t,n;w(e([f[0],u[0]]),{display:"block",width:""},function(){var e;e=f.outerWidth()-f.width(),t=c+e,n=c}),u.width(t),f.width(n)}var o,u,f,c,h;return n.selectAutoWidth&&p(),o=l(t,n,{divClass:n.selectClass,spanHtml:(t.find(":selected:first")||t.find("option:first")).html(),spanWrap:"before"}),u=o.div,f=o.span,n.selectAutoWidth?d():u.addClass("fixedWidth"),i(t,u,n),r(t,n,{change:function(){f.html(t.find(":selected").html()),u.removeClass(n.activeClass)},"click touchend":function(){var e=t.find(":selected").html();f.html()!==e&&t.trigger("change")},keyup:function(){f.html(t.find(":selected").html())}}),y(f,n),{remove:function(){return f.remove(),t.unwrap().unbind(n.eventNamespace),t},update:function(){n.selectAutoWidth&&p(),s(u,n),f.html(t.find(":selected:first").html()),a(u,t,n),n.selectAutoWidth&&d()}}}},{match:function(e){return e.is("select")&&m(e)?!0:!1},apply:function(e,t){var n;return e.addClass(t.selectMultiClass),n=c(e,t),i(e,e,t),{remove:function(){e.removeClass(t.selectMultiClass),n&&e.unwrap()},update:g}}},{match:function(e){return e.is("textarea")},apply:function(e,t){var n;return e.addClass(t.textareaClass),n=c(e,t),i(e,e,t),{remove:function(){e.removeClass(t.textareaClass),n&&e.unwrap()},update:g}}}];d()&&!v()&&(x=!1),e.uniform={defaults:{activeClass:"active",autoHide:!0,buttonClass:"button",checkboxClass:"checker",checkedClass:"checked",disabledClass:"disabled",eventNamespace:".uniform",fileButtonClass:"action",fileButtonHtml:"Choose File",fileClass:"uploader",fileDefaultHtml:"No file selected",filenameClass:"filename",focusClass:"focus",hoverClass:"hover",idPrefix:"uniform",inputAddTypeAsClass:!0,inputClass:"uniform-input",radioClass:"radio",resetDefaultHtml:"Reset",resetSelector:!1,selectAutoWidth:!0,selectClass:"selector",selectMultiClass:"uniform-multiselect",submitDefaultHtml:"Submit",textareaClass:"uniform",useID:!0,wrapperClass:null},elements:[]},e.fn.uniform=function(t){var n=this;return t=e.extend({},e.uniform.defaults,t),T||(T=!0,h()&&(x=!1)),x?(t.resetSelector&&e(t.resetSelector).mouseup(function(){window.setTimeout(function(){e.uniform.update(n)},10)}),this.each(function(){var n=e(this),r,i,s;if(n.data("uniformed")){e.uniform.update(n);return}for(r=0;r<N.length;r+=1){i=N[r];if(i.match(n,t)){s=i.apply(n,t),n.data("uniformed",s),e.uniform.elements.push(n.get(0));return}}})):this},e.uniform.restore=e.fn.uniform.restore=function(n){n===t&&(n=e.uniform.elements),e(n).each(function(){var t=e(this),n,r;r=t.data("uniformed");if(!r)return;r.remove(),n=e.inArray(this,e.uniform.elements),n>=0&&e.uniform.elements.splice(n,1),t.removeData("uniformed")})},e.uniform.update=e.fn.uniform.update=function(n){n===t&&(n=e.uniform.elements),e(n).each(function(){var t=e(this),n;n=t.data("uniformed");if(!n)return;n.update(t,n.options)})}})(jQuery);