/**
 * JustGage - a handy JavaScript plugin for generating and animating nice & clean dashboard gauges.
 * Copyright (c) 2012 Bojan Djuricic - pindjur(at)gmail(dot)com | http://www.madcog.com
 * Licensed under MIT.
 * Date: 31/07/2012
 * @author Bojan Djuricic  (@Toorshia)
 * @version 1.0
 *
 * http://www.justgage.com
 */
function getRandomInt(e,t){return Math.floor(Math.random()*(t-e+1))+e}function cutHex(e){return e.charAt(0)=="#"?e.substring(1,7):e}function getStyle(e,t){var n="";return document.defaultView&&document.defaultView.getComputedStyle?n=document.defaultView.getComputedStyle(e,"").getPropertyValue(t):e.currentStyle&&(t=t.replace(/\-(\w)/g,function(e,t){return t.toUpperCase()}),n=e.currentStyle[t]),n}function onCreateElementNsReady(e){document.createElementNS!=undefined?e():setTimeout(function(){onCreateElementNsReady(e)},100)}JustGage=function(e){if(!e.id)return alert("Missing id parameter for gauge!"),!1;if(!document.getElementById(e.id))return alert('No element with id: "'+e.id+'" found!'),!1;this.config={id:e.id,title:e.title?e.title:"Title",titleFontColor:e.titleFontColor?e.titleFontColor:"#999999",value:e.value?e.value:0,valueFontColor:e.valueFontColor?e.valueFontColor:"#010101",min:e.min?e.min:0,max:e.max?e.max:100,showMinMax:e.showMinMax!=null?e.showMinMax:!0,gaugeWidthScale:e.gaugeWidthScale?e.gaugeWidthScale:1,gaugeColor:e.gaugeColor?e.gaugeColor:"#edebeb",label:e.label?e.label:"",showInnerShadow:e.showInnerShadow!=null?e.showInnerShadow:!0,shadowOpacity:e.shadowOpacity?e.shadowOpacity:.2,shadowSize:e.shadowSize?e.shadowSize:5,shadowVerticalOffset:e.shadowVerticalOffset?e.shadowVerticalOffset:3,levelColors:e.levelColors?e.levelColors:percentColors,levelColorsGradient:e.levelColorsGradient!=null?e.levelColorsGradient:!0,labelFontColor:e.labelFontColor?e.labelFontColor:"#b3b3b3",startAnimationTime:e.startAnimationTime?e.startAnimationTime:700,startAnimationType:e.startAnimationType?e.startAnimationType:">",refreshAnimationTime:e.refreshAnimationTime?e.refreshAnimationTime:700,refreshAnimationType:e.refreshAnimationType?e.refreshAnimationType:">"},e.value>this.config.max&&(this.config.value=this.config.max),e.value<this.config.min&&(this.config.value=this.config.min),this.originalValue=e.value,this.canvas=Raphael(this.config.id,"100%","100%");var t=getStyle(document.getElementById(this.config.id),"width").slice(0,-2)*1,n=getStyle(document.getElementById(this.config.id),"height").slice(0,-2)*1,r,i;t/n>1.25?(r=1.25*n,i=n):(r=t,i=t/1.25);var s=(t-r)/2,o=(n-i)/2,u=i/8>10?i/10:10,a=s+r/2,f=o+i/6.5,l=i/6.4>16?i/6.4:16,c=s+r/2,h=o+i/1.4,p=i/16>10?i/16:10,d=s+r/2,v=h+l/2+6,m=i/16>10?i/16:10,g=s+r/10+r/6.666666666666667*this.config.gaugeWidthScale/2,y=o+i/1.126760563380282,b=i/16>10?i/16:10,w=s+r-r/10-r/6.666666666666667*this.config.gaugeWidthScale/2,E=o+i/1.126760563380282;this.params={canvasW:t,canvasH:n,widgetW:r,widgetH:i,dx:s,dy:o,titleFontSize:u,titleX:a,titleY:f,valueFontSize:l,valueX:c,valueY:h,labelFontSize:p,labelX:d,labelY:v,minFontSize:m,minX:g,minY:y,maxFontSize:b,maxX:w,maxY:E},this.canvas.customAttributes.pki=function(e,t,n,r,i,s,o,u){var a=(1-(e-t)/(n-t))*Math.PI,f=r/2-r/10,l=f-r/6.666666666666667*u,c=r/2+s,h=i/1.25+o,p=r/2+s+f*Math.cos(a),d=i-(i-h)+o-f*Math.sin(a),v=r/2+s+l*Math.cos(a),m=i-(i-h)+o-l*Math.sin(a),g;return g+="M"+(c-l)+","+h+" ",g+="L"+(c-f)+","+h+" ",g+="A"+f+","+f+" 0 0,1 "+p+","+d+" ",g+="L"+v+","+m+" ",g+="A"+l+","+l+" 0 0,0 "+(c-l)+","+h+" ",g+="z ",{path:g}},this.gauge=this.canvas.path().attr({stroke:"none",fill:this.config.gaugeColor,pki:[this.config.max,this.config.min,this.config.max,this.params.widgetW,this.params.widgetH,this.params.dx,this.params.dy,this.config.gaugeWidthScale]}),this.gauge.id=this.config.id+"-gauge",this.level=this.canvas.path().attr({stroke:"none",fill:getColorForPercentage((this.config.value-this.config.min)/(this.config.max-this.config.min),this.config.levelColors,this.config.levelColorsGradient),pki:[this.config.min,this.config.min,this.config.max,this.params.widgetW,this.params.widgetH,this.params.dx,this.params.dy,this.config.gaugeWidthScale]}),this.level.id=this.config.id+"-level",this.txtTitle=this.canvas.text(this.params.titleX,this.params.titleY,this.config.title),this.txtTitle.attr({"font-size":this.params.titleFontSize,"font-weight":"bold","font-family":"Arial",fill:this.config.titleFontColor,"fill-opacity":"1"}),this.txtTitle.id=this.config.id+"-txttitle",this.txtValue=this.canvas.text(this.params.valueX,this.params.valueY,this.originalValue),this.txtValue.attr({"font-size":this.params.valueFontSize,"font-weight":"bold","font-family":"Arial",fill:this.config.valueFontColor,"fill-opacity":"0"}),this.txtValue.id=this.config.id+"-txtvalue",this.txtLabel=this.canvas.text(this.params.labelX,this.params.labelY,this.config.label),this.txtLabel.attr({"font-size":this.params.labelFontSize,"font-weight":"normal","font-family":"Arial",fill:this.config.labelFontColor,"fill-opacity":"0"}),this.txtLabel.id=this.config.id+"-txtlabel",this.txtMin=this.canvas.text(this.params.minX,this.params.minY,this.config.min),this.txtMin.attr({"font-size":this.params.minFontSize,"font-weight":"normal","font-family":"Arial",fill:this.config.labelFontColor,"fill-opacity":this.config.showMinMax==1?"1":"0"}),this.txtMin.id=this.config.id+"-txtmin",this.txtMax=this.canvas.text(this.params.maxX,this.params.maxY,this.config.max),this.txtMax.attr({"font-size":this.params.maxFontSize,"font-weight":"normal","font-family":"Arial",fill:this.config.labelFontColor,"fill-opacity":this.config.showMinMax==1?"1":"0"}),this.txtMax.id=this.config.id+"-txtmax";var S=this.canvas.canvas.childNodes[1],x="http://www.w3.org/2000/svg";ie<9?onCreateElementNsReady(function(){this.generateShadow()}):this.generateShadow(x,S),this.level.animate({pki:[this.config.value,this.config.min,this.config.max,this.params.widgetW,this.params.widgetH,this.params.dx,this.params.dy,this.config.gaugeWidthScale]},this.config.startAnimationTime,this.config.startAnimationType),this.txtValue.animate({"fill-opacity":"1"},this.config.startAnimationTime,this.config.startAnimationType),this.txtLabel.animate({"fill-opacity":"1"},this.config.startAnimationTime,this.config.startAnimationType)},JustGage.prototype.refresh=function(e){originalVal=e,e>this.config.max&&(e=this.config.max),e<this.config.min&&(e=this.config.min);var t=getColorForPercentage((e-this.config.min)/(this.config.max-this.config.min),this.config.levelColors,this.config.levelColorsGradient);this.canvas.getById(this.config.id+"-txtvalue").attr({text:originalVal}),this.canvas.getById(this.config.id+"-level").animate({pki:[e,this.config.min,this.config.max,this.params.widgetW,this.params.widgetH,this.params.dx,this.params.dy,this.config.gaugeWidthScale],fill:t},this.config.refreshAnimationTime,this.config.refreshAnimationType)};var percentColors=["#a9d70b","#f9c802","#ff0000"];JustGage.prototype.generateShadow=function(e,t){var n=document.createElementNS(e,"filter");n.setAttribute("id",this.config.id+"-inner-shadow"),t.appendChild(n);var r=document.createElementNS(e,"feOffset");r.setAttribute("dx",0),r.setAttribute("dy",this.config.shadowVerticalOffset),n.appendChild(r);var i=document.createElementNS(e,"feGaussianBlur");i.setAttribute("result","offset-blur"),i.setAttribute("stdDeviation",this.config.shadowSize),n.appendChild(i);var s=document.createElementNS(e,"feComposite");s.setAttribute("operator","out"),s.setAttribute("in","SourceGraphic"),s.setAttribute("in2","offset-blur"),s.setAttribute("result","inverse"),n.appendChild(s);var o=document.createElementNS(e,"feFlood");o.setAttribute("flood-color","black"),o.setAttribute("flood-opacity",this.config.shadowOpacity),o.setAttribute("result","color"),n.appendChild(o);var u=document.createElementNS(e,"feComposite");u.setAttribute("operator","in"),u.setAttribute("in","color"),u.setAttribute("in2","inverse"),u.setAttribute("result","shadow"),n.appendChild(u);var a=document.createElementNS(e,"feComposite");a.setAttribute("operator","over"),a.setAttribute("in","shadow"),a.setAttribute("in2","SourceGraphic"),n.appendChild(a),this.config.showInnerShadow==1&&(this.canvas.canvas.childNodes[2].setAttribute("filter","url(#"+this.config.id+"-inner-shadow)"),this.canvas.canvas.childNodes[3].setAttribute("filter","url(#"+this.config.id+"-inner-shadow)"))};var getColorForPercentage=function(e,t,n){var r=t.length;if(r===1)return t[0];var i=n?1/(r-1):1/r,s=new Array;for(var o=0;o<t.length;o++){var u=n?i*o:i*(o+1),a=parseInt(cutHex(t[o]).substring(0,2),16),f=parseInt(cutHex(t[o]).substring(2,4),16),l=parseInt(cutHex(t[o]).substring(4,6),16);s[o]={pct:u,color:{r:a,g:f,b:l}}}if(e==0)return"rgb("+[s[0].color.r,s[0].color.g,s[0].color.b].join(",")+")";for(var o=0;o<s.length;o++)if(e<=s[o].pct){if(n==1){var c=s[o-1],h=s[o],p=h.pct-c.pct,d=(e-c.pct)/p,v=1-d,m=d,g={r:Math.floor(c.color.r*v+h.color.r*m),g:Math.floor(c.color.g*v+h.color.g*m),b:Math.floor(c.color.b*v+h.color.b*m)};return"rgb("+[g.r,g.g,g.b].join(",")+")"}return"rgb("+[s[o].color.r,s[o].color.g,s[o].color.b].join(",")+")"}},ie=function(){var e,t=3,n=document.createElement("div"),r=n.getElementsByTagName("i");while(n.innerHTML="<!--[if gt IE "+ ++t+"]><i></i><![endif]-->",r[0]);return t>4?t:e}();